// APPHelper.h: interface for the APPHelper class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_APPHELPER_H__F41D99AE_3171_426F_B928_7854773D682A__INCLUDED_)
#define AFX_APPHELPER_H__F41D99AE_3171_426F_B928_7854773D682A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//  Aml Pages Plugin API
#include "Plugins.h"

/*
      Aml Pages
  , ..        
   APPHelper::FunctionName(...)
*/

enum AML_OPTIONS_COLORS {AOC_TREEBK=0,AOC_TREEFONT=1, AOC_EDITORBK=2, AOC_EDITORFONT=4};
enum AML_OPTIONS_FONTS  {AOF_TREEFONT=0, AOF_EDITORFONT=1};

struct APPHelper  
{
	static BOOL RemoveAttachmentToRecycledBin(const WORD wDocID, const int nIndex);//Move attachment to Recycled
	static BOOL IsHasAPC_REMOVEATTACHMENTEX();
	static WORD GetUILanguage();//Get UI language (LANG_ENGLISH, LANG_RUSSIAN and etc)
	static UINT MessageBoxWith2Radio(const HWND hwndParent, UINT nType, LPCTSTR lpszTitle, LPCTSTR lpszText, LPCTSTR lpszRadio1, LPCTSTR lpszRadio2, UINT& nRadio);//MessageBox with radio buttons
	static int GetActivePage(const WORD wDocID=AML_ACTIVEDOCUMENTID);//get selected page of document
	static BOOL GetAttachment(const WORD wDocID, const int nIndex, AML_ATTACHINFO* p);//Get attachment data from document
	static int EnumAttachments(WORD wDocID, PFUNC_ENUMATTACHMENTSPROC pfn, LPARAM lParam, LPCTSTR lpszINFOID=NULL, int nPageID=(AML_NOCHECKPAGEID));//enumerate attachments
	static BOOL AddAttachment(WORD wDocID, AML_ATTACHINFO* p);//insert attachment
	static BOOL SetAttachment(WORD wDocID, int nIndex, AML_ATTACHINFO* p);//change attachment in document
	static BOOL RemoveAttachment(WORD wDocID, int nIndex);//Remove attachment from document (completelly)
	static BOOL AddStringToAttachment(WORD wDocID,LPCTSTR lpsz, LPCTSTR lpszInfoID, const int nPageID);// C-     
	
	static LRESULT Command(UINT nCmd, WPARAM wParam, LPARAM lParam);//  ( ,  ,    ..)
	static BOOL MessageBoxWithCheckBoxEx(AML_MBCHECKINFO* pInfo);//MessageBox    
	static BOOL SetStatusBarText(BSTR bstr);//    Aml Pages
	static BOOL MessageBoxWithRadioBox(AML_MBRADIOINFO* pInfo);// MessageBox     (radiobuttons)
	static BOOL GetModuleVersionInfoEx(HMODULE hModule, AML_MODULEVERSIONINFO* pInfo);//  
	static BOOL RichOut(AML_RICHEDITIO *p);//   RichEdit
	static BOOL RichIn(AML_RICHEDITIO *p);//   RichEdit
	static BOOL PluginAbout(AML_PLUGINABOUTINFO* pInfo);//  
	static BOOL GetAutoTextCommand(AML_AUTOTEXTCOMMAND* pCmd);//  
	static BOOL GetOptions(AML_OPTIONS* pOpt);//   Aml Pages
	static BOOL ReReadPluginsInfo(HMODULE hModule);//    Aml Pages (hModule -           )
	static BOOL GetModuleVersionInfo(LPCTSTR lpszPathName/*  */, AML_MODULEVERSIONINFO* pVersionInfo/*   */);
	static UINT GetAmlPagesBuildNumber();//   Aml Pages
	static HWND GetMainHWND();// HWND   Aml Pages
	static BOOL ConvertText(LPCTSTR lpszInText/* */,BSTR* pbstrOutText/*  -   */, const BOOL bRTF2Text/*TRUE -  RTF   , FALSE -     */);//  RTF<->PlainText
	static BOOL MessageBoxWithCheckBox(LPCTSTR lpszText/* */,UINT uType/* */,LPCTSTR lpszCheckBoxText/* */,BOOL* pbChecked/* ,   */,int* pnRet/*  MessageBox*/);// MessageBox  
	static BOOL DisplayPasswordDialog(BSTR* pbstrPassword/*  -   */,BOOL bSetupPassword/*TRUE -  ,  */,BOOL bTopMost/*TRUE -   */,LPCTSTR lpszPrevPassword/*. ,   NULL*/,BOOL bShowOnEnter/*   */,LPCTSTR lpszTitle/*   */);//  
	static BOOL PluginAbout(LPCTSTR lpszAbout, LPCTSTR lpszCopy, LPCTSTR lpszLink, LPCTSTR lpszNameVersion, LPCTSTR lpszURLToolTip, LPCTSTR lpszTitle,const HICON hIcon, LPCTSTR lpszLinkText);//  " "
	static BOOL RichInRTFTextSel(const HWND hwnd, LPCTSTR lpszText);//   RTF
	static BOOL RichInRTFTextAll(const HWND hwnd, LPCTSTR lpszText);//   RTF
	static BOOL RichInPlainTextSel(const HWND hwnd, LPCTSTR lpszText);//   
	static BOOL RichInPlainTextAll(const HWND hwnd, LPCTSTR lpszText);//   
	static BOOL SetStatusBarText(LPCTSTR lpszText);//    
private:
	static BOOL RichIn(const HWND hwnd, LPCTSTR lpszText, const bool bAsPlainText, const bool bSel);	
public:
	static BOOL ExecUserCommand(const WPARAM wParam,const LPARAM lParam);
	static WORD DocumentPathToID(LPCTSTR lpszDocumentPath);
	static BOOL GetModuleVersionInfoOfAmlPages(AML_MODULEVERSIONINFO* pVersionInfo);
	static BOOL SetOptions(const AML_OPTIONS* const pOpt);
	static BOOL DisplayActiveDocumentAsStickyNote(const int nPageID, const BOOL bDisplay);//display or hide page as sticky note in active document
	static BOOL DisplayAsStickyNote(const WORD wDocID, const int nPageID, const BOOL bDisplay);//display or hide page as sticky note
	static HICON ExtractPageIconFromActiveDocument(const int nPageID);////extract page icon from active document (user defined or standard)
	static HICON ExtractPageIcon(const WORD wDocumentID, const int nPageID);//extract page icon (user defined or standard)
	static BOOL DisplayFavoritesMenuForActiveDocument(POINT pt);//Display favorites menu on point
	static BOOL NewStickyNoteToTheDocument(const BOOL bInsertClipboardToContent, LPCTSTR lpszDocumentPath);
	static int ReadTipOfTheDay(const UINT nBufferInBytesSize, LPTSTR lpszBuffer);//read tip of the day from tips.txt
	static BOOL GetFilenameFromPath(LPCTSTR lpszPath, LPTSTR lpszFilename, const UINT nSize);//get filename.extension only from full path name
	static BOOL IsReadOnlyActiveDocument();//active document is read only?
	static BOOL IsReadOnlyDocument(const WORD wDocID);//document is read only?
	static void GetPluginsDirectory(char* psz, const UINT n);//get directory of plugins
	static UINT GetManagementFilesList(const UINT cbBufferBytes, char* const pBuffer);//get list of My Files
	static UINT GetManagementFilesListSizeInBytes();//get bytes neeeded for list of My Files
	static BOOL SelectPage(const WORD wDocID, const int nPageID, const DWORD dwCursorPos);//show dialog for node selection
	static int DisplayFolderDialogForActiveDoc(const int nSelFolderID, RECT* pRectDlg);
	static CHARFORMAT GetAmlEditorFontAsCHARFORMAT();//get editor font as CHARFORMAT structure
	static LOGFONT GetAmlEditorFont();//get editor font as LOGFONT structure
	static LOGFONT GetAmlTreeFont();//get tree font as LOGFONT structure
	static int ImportFileToActiveDoc(LPCTSTR lpszPathName);//import file to active doc. RetVal: PageID or success, -1 or fail
	static BOOL ShowPageInTreeInActiveDoc(const int nPageID);//display node in active document tree
	static BOOL ShowPageInTree(const WORD wDocID, const int nPageID);//display node in document tree (with document ID)
	static BOOL MinimizeMainWindow();//minimize Aml Pages main window
	static BOOL RestoreMainWindow();//restore Aml Pages main window
	static WORD OpenDocumentEx(LPCTSTR lpszFullPathName, const int nPageID);//open document and select node (with ID==nPageID)
	static int GetActiveDocumentPath(UINT nBytes, LPTSTR lpszPath);//get path of the active document (or title, is not saved)
	static int GetActiveDocumentPathNeedBytes();//get bytes for active document path
	static COLORREF GetAmlColor(const AML_OPTIONS_COLORS colorType);//get colors of Aml Pages (options)
	static BOOL CopyOrMoveNode(const int nCopiedNodeID, const int nTargetNodeID, const BOOL bCopy);
	static BOOL MoveNode(const int nCopiedNodeID, const int nTargetNodeID);//copy node nCopiedNode to nTargetNodeID(Folder)
	static BOOL CopyNode(const int nCopiedNodeID, const int nTargetNodeID);//move node nCopiedNode to nTargetNodeID(Folder)
	static WORD OpenDocument(LPCTSTR lpszDocFullPathName);//opend document by full path name
	static UINT GetMruList(const UINT nBytes, LPTSTR lpszFileList);//get list of most recently used files
	static UINT GetMruListSizeInBytes();//get number of bytes needed for GetMruList
	static void NewStickyNote(const BOOL bInsertClipboardToContent);//create new sticky note is the active document
	static BOOL ShowTree(const WORD wDocID, const BOOL bShow);//show tree pane in document
	static int GetPageHeaderBytesNeed(const int nPageID);//get number of bytes required for GetPageHeader
	static int GetPageHeader(const int nPageID, LPTSTR lpszHeader);//get header of node 
	static int GetActivePageID(const WORD wDocumentID=AML_ACTIVEDOCUMENTID);//get selected node id
};

#endif // !defined(AFX_APPHELPER_H__F41D99AE_3171_426F_B928_7854773D682A__INCLUDED_)
