// CSysImageList.cpp: implementation of the CSysImageList class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "SysImageList.h"
#include <shellapi.h>

CSysImageList::CSysImageList():m_hIml(NULL)
{
}

CSysImageList::~CSysImageList()
{
}

/* HICON    */
HICON CSysImageList::GetIcon(LPCTSTR lpszPath)
{
	ASSERT(lpszPath);
	if (!lpszPath) return NULL;
	if (!strlen(lpszPath)) return NULL;

	if (!IsAttached()) {
		const bool b=Attach();
		ASSERT(true==b);
		if (!b) return NULL;
	}

	SHFILEINFO shfi={0};

	UINT flags=SHGFI_ICON|SHGFI_SMALLICON;
	const int nRet=::SHGetFileInfo(lpszPath,0,&shfi,sizeof(SHFILEINFO),flags);

	return shfi.hIcon;
}

/* HIMAGELIST   */
bool CSysImageList::Attach()
{
	/* !?!?*/
	if (IsAttached()) return false;

	/**/
	HRESULT     hRes   = NULL;
	SHFILEINFO  shfi;
	ITEMIDLIST* pidl;
	IMalloc*    pMalloc;

	CoInitialize(NULL);
		
	hRes   = SHGetSpecialFolderLocation(NULL, CSIDL_DESKTOP, &pidl);
	if (hRes!=S_OK) return false;
	
	m_hIml= (HIMAGELIST)SHGetFileInfo((LPCSTR)pidl, 0, &shfi,
					sizeof(SHFILEINFO), 
					SHGFI_PIDL | 
					SHGFI_SYSICONINDEX|SHGFI_SMALLICON);

	hRes = SHGetMalloc(&pMalloc);
	pMalloc->Free(pidl);
	pMalloc->Release();
	
	return (NULL!=m_hIml);
}

/*     HIMAGELIST*/
bool CSysImageList::IsAttached() const
{
	return (NULL!=m_hIml);
}

/* singleton` -    */
CSysImageList& CSysImageList::GetSysImageList()
{
	static CSysImageList iml;
	return iml;
}
